org.apache.http.impl.conn.tsccm

## Class ThreadSafeClientConnManager

- java.lang.Object
- - org.apache.http.impl.conn.tsccm.ThreadSafeClientConnManager

- All Implemented Interfaces:
    ClientConnectionManager

  Deprecated.
  (4.2) use `PoolingHttpClientConnectionManager`

      @Contract(threading=SAFE_CONDITIONAL)
      @Deprecated
      public class ThreadSafeClientConnManager
      extends Object
      implements ClientConnectionManager

  Manages a pool of `OperatedClientConnection` and is able to service connection requests from multiple execution threads. Connections are pooled on a per route basis. A request for a route which already the manager has persistent connections for available in the pool will be services by leasing a connection from the pool rather than creating a brand new connection.

  ThreadSafeClientConnManager maintains a maximum limit of connection on a per route basis and in total. Per default this implementation will create no more than than 2 concurrent connections per given route and no more 20 connections in total. For many real-world applications these limits may prove too constraining, especially if they use HTTP as a transport protocol for their services. Connection limits, however, can be adjusted using HTTP parameters.

  Since:
    4.0

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `protected AbstractConnPool` | `connectionPool` Deprecated.
    `protected ClientConnectionOperator` | `connOperator` Deprecated. The operator for opening and updating connections.
    `protected ConnPerRouteBean` | `connPerRoute` Deprecated.
    `protected ConnPoolByRoute` | `pool` Deprecated. The pool of connections being managed.
    `protected SchemeRegistry` | `schemeRegistry` Deprecated. The schemes supported by this connection manager.

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `ThreadSafeClientConnManager()` Deprecated.
    `ThreadSafeClientConnManager(org.apache.http.params.HttpParams params, SchemeRegistry schreg)` Deprecated. (4.1) use `ThreadSafeClientConnManager(SchemeRegistry)`
    `ThreadSafeClientConnManager(SchemeRegistry schreg)` Deprecated. Creates a new thread safe connection manager.
    `ThreadSafeClientConnManager(SchemeRegistry schreg, long connTTL, TimeUnit connTTLTimeUnit)` Deprecated. Creates a new thread safe connection manager.
    `ThreadSafeClientConnManager(SchemeRegistry schreg, long connTTL, TimeUnit connTTLTimeUnit, ConnPerRouteBean connPerRoute)` Deprecated. Creates a new thread safe connection manager.

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `closeExpiredConnections()` Deprecated. Closes all expired connections in the pool.
    `void` | `closeIdleConnections(long idleTimeout, TimeUnit timeUnit)` Deprecated. Closes idle connections in the pool.
    `protected ClientConnectionOperator` | `createConnectionOperator(SchemeRegistry schreg)` Deprecated. Hook for creating the connection operator.
    `protected AbstractConnPool` | `createConnectionPool(org.apache.http.params.HttpParams params)` Deprecated. (4.1) use #createConnectionPool(long, TimeUnit))
    `protected ConnPoolByRoute` | `createConnectionPool(long connTTL, TimeUnit connTTLTimeUnit)` Deprecated. Hook for creating the connection pool.
    `protected void` | `finalize()` Deprecated.
    `int` | `getConnectionsInPool()` Deprecated. Gets the total number of pooled connections.
    `int` | `getConnectionsInPool(HttpRoute route)` Deprecated. Gets the total number of pooled connections for the given route.
    `int` | `getDefaultMaxPerRoute()` Deprecated.
    `int` | `getMaxForRoute(HttpRoute route)` Deprecated.
    `int` | `getMaxTotal()` Deprecated. since 4.1
    `SchemeRegistry` | `getSchemeRegistry()` Deprecated. Obtains the scheme registry used by this manager.
    `void` | `releaseConnection(ManagedClientConnection conn, long validDuration, TimeUnit timeUnit)` Deprecated. Releases a connection for use by others.
    `ClientConnectionRequest` | `requestConnection(HttpRoute route, Object state)` Deprecated. Returns a new `ClientConnectionRequest`, from which a `ManagedClientConnection` can be obtained or the request can be aborted.
    `void` | `setDefaultMaxPerRoute(int max)` Deprecated.
    `void` | `setMaxForRoute(HttpRoute route, int max)` Deprecated.
    `void` | `setMaxTotal(int max)` Deprecated. since 4.1
    `void` | `shutdown()` Deprecated. Shuts down this connection manager and releases allocated resources.

    - ### Methods inherited from class java.lang.Object

      `clone, equals, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### schemeRegistry

          protected final SchemeRegistry schemeRegistry

      Deprecated.
      The schemes supported by this connection manager.

    - #### connectionPool

          protected final AbstractConnPool connectionPool

      Deprecated.

    - #### pool

          protected final ConnPoolByRoute pool

      Deprecated.
      The pool of connections being managed.

    - #### connOperator

          protected final ClientConnectionOperator connOperator

      Deprecated.
      The operator for opening and updating connections.

    - #### connPerRoute

          protected final ConnPerRouteBean connPerRoute

      Deprecated.

  - ### Constructor Detail

    - #### ThreadSafeClientConnManager

          public ThreadSafeClientConnManager(SchemeRegistry schreg)

      Deprecated.
      Creates a new thread safe connection manager.
      Parameters:
        `schreg` - the scheme registry.

    - #### ThreadSafeClientConnManager

          public ThreadSafeClientConnManager()

      Deprecated.
      Since:
        4.1

    - #### ThreadSafeClientConnManager

          public ThreadSafeClientConnManager(SchemeRegistry schreg,
                                     long connTTL,
                                     TimeUnit connTTLTimeUnit)

      Deprecated.
      Creates a new thread safe connection manager.
      Parameters:
        `schreg` - the scheme registry.
        `connTTL` - max connection lifetime, <=0 implies "infinity"
        `connTTLTimeUnit` - TimeUnit of connTTL
      Since:
        4.1

    - #### ThreadSafeClientConnManager

          public ThreadSafeClientConnManager(SchemeRegistry schreg,
                                     long connTTL,
                                     TimeUnit connTTLTimeUnit,
                                     ConnPerRouteBean connPerRoute)

      Deprecated.
      Creates a new thread safe connection manager.
      Parameters:
        `schreg` - the scheme registry.
        `connTTL` - max connection lifetime, <=0 implies "infinity"
        `connTTLTimeUnit` - TimeUnit of connTTL
        `connPerRoute` - mapping of maximum connections per route, provided as a dependency so it can be managed externally, e.g. for dynamic connection pool size management.
      Since:
        4.2

    - #### ThreadSafeClientConnManager

          @Deprecated
          public ThreadSafeClientConnManager(org.apache.http.params.HttpParams params,
                                                SchemeRegistry schreg)

      Deprecated. (4.1) use `ThreadSafeClientConnManager(SchemeRegistry)`
      Creates a new thread safe connection manager.
      Parameters:
        `params` - the parameters for this manager.
        `schreg` - the scheme registry.

  - ### Method Detail

    - #### finalize

          protected void finalize()
                           throws Throwable

      Deprecated.
      Overrides:
        `finalize` in class `Object`
      Throws:
        `Throwable`

    - #### createConnectionPool

          @Deprecated
          protected AbstractConnPool createConnectionPool(org.apache.http.params.HttpParams params)

      Deprecated. (4.1) use #createConnectionPool(long, TimeUnit))
      Hook for creating the connection pool.
      Returns:
        the connection pool to use

    - #### createConnectionPool

          protected ConnPoolByRoute createConnectionPool(long connTTL,
                                             TimeUnit connTTLTimeUnit)

      Deprecated.
      Hook for creating the connection pool.
      Returns:
        the connection pool to use
      Since:
        4.1

    - #### createConnectionOperator

          protected ClientConnectionOperator createConnectionOperator(SchemeRegistry schreg)

      Deprecated.
      Hook for creating the connection operator. It is called by the constructor. Derived classes can override this method to change the instantiation of the operator. The default implementation here instantiates `DefaultClientConnectionOperator`.
      Parameters:
        `schreg` - the scheme registry.
      Returns:
        the connection operator to use

    - #### getSchemeRegistry

          public SchemeRegistry getSchemeRegistry()

      Deprecated.
      Description copied from interface: `ClientConnectionManager`
      Obtains the scheme registry used by this manager.
      Specified by:
        `getSchemeRegistry` in interface `ClientConnectionManager`
      Returns:
        the scheme registry, never `null`

    - #### requestConnection

          public ClientConnectionRequest requestConnection(HttpRoute route,
                                                  Object state)

      Deprecated.
      Description copied from interface: `ClientConnectionManager`
      Returns a new `ClientConnectionRequest`, from which a `ManagedClientConnection` can be obtained or the request can be aborted.
      Specified by:
        `requestConnection` in interface `ClientConnectionManager`

    - #### releaseConnection

          public void releaseConnection(ManagedClientConnection conn,
                               long validDuration,
                               TimeUnit timeUnit)

      Deprecated.
      Description copied from interface: `ClientConnectionManager`
      Releases a connection for use by others. You may optionally specify how long the connection is valid to be reused. Values <= 0 are considered to be valid forever. If the connection is not marked as reusable, the connection will not be reused regardless of the valid duration. If the connection has been released before, the call will be ignored.
      Specified by:
        `releaseConnection` in interface `ClientConnectionManager`
      Parameters:
        `conn` - the connection to release
        `validDuration` - the duration of time this connection is valid for reuse
        `timeUnit` - the unit of time validDuration is measured in
      See Also:
        `ClientConnectionManager.closeExpiredConnections()`

    - #### shutdown

          public void shutdown()

      Deprecated.
      Description copied from interface: `ClientConnectionManager`
      Shuts down this connection manager and releases allocated resources. This includes closing all connections, whether they are currently used or not.
      Specified by:
        `shutdown` in interface `ClientConnectionManager`

    - #### getConnectionsInPool

          public int getConnectionsInPool(HttpRoute route)

      Deprecated.
      Gets the total number of pooled connections for the given route. This is the total number of connections that have been created and are still in use by this connection manager for the route. This value will not exceed the maximum number of connections per host.
      Parameters:
        `route` - the route in question
      Returns:
        the total number of pooled connections for that route

    - #### getConnectionsInPool

          public int getConnectionsInPool()

      Deprecated.
      Gets the total number of pooled connections. This is the total number of connections that have been created and are still in use by this connection manager. This value will not exceed the maximum number of connections in total.
      Returns:
        the total number of pooled connections

    - #### closeIdleConnections

          public void closeIdleConnections(long idleTimeout,
                                  TimeUnit timeUnit)

      Deprecated.
      Description copied from interface: `ClientConnectionManager`
      Closes idle connections in the pool. Open connections in the pool that have not been used for the timespan given by the argument will be closed. Currently allocated connections are not subject to this method. Times will be checked with milliseconds precision All expired connections will also be closed.
      Specified by:
        `closeIdleConnections` in interface `ClientConnectionManager`
      Parameters:
        `idleTimeout` - the idle time of connections to be closed
        `timeUnit` - the unit for the `idletime`
      See Also:
        `ClientConnectionManager.closeExpiredConnections()`

    - #### closeExpiredConnections

          public void closeExpiredConnections()

      Deprecated.
      Description copied from interface: `ClientConnectionManager`
      Closes all expired connections in the pool. Open connections in the pool that have not been used for the timespan defined when the connection was released will be closed. Currently allocated connections are not subject to this method. Times will be checked with milliseconds precision.
      Specified by:
        `closeExpiredConnections` in interface `ClientConnectionManager`

    - #### getMaxTotal

          public int getMaxTotal()

      Deprecated.
      since 4.1

    - #### setMaxTotal

          public void setMaxTotal(int max)

      Deprecated.
      since 4.1

    - #### getDefaultMaxPerRoute

          public int getDefaultMaxPerRoute()

      Deprecated.
      Since:
        4.1

    - #### setDefaultMaxPerRoute

          public void setDefaultMaxPerRoute(int max)

      Deprecated.
      Since:
        4.1

    - #### getMaxForRoute

          public int getMaxForRoute(HttpRoute route)

      Deprecated.
      Since:
        4.1

    - #### setMaxForRoute

          public void setMaxForRoute(HttpRoute route,
                            int max)

      Deprecated.
      Since:
        4.1

Copyright © 1999–2022 The Apache Software Foundation. All rights reserved.